<!--  -->
<template>
  <div
    class="versions_updateHistory_box"
    :style="'height:' + fullHeight + 'px'"
    v-loading="loading"
  >
    <!-- 头部 -->
    <div class="versions_updateHistory_head">
      <div class="versions_updateHistory_head_returnA" @click="FanHui()">
        <img src="../../assets/image/left.png" alt class="versions_updateHistory_head_returnA_img" />
      </div>

      <!-- 标题 -->
      <div class="head_title">
        <span class="head_title_text">版本更新历史记录</span>
      </div>
    </div>

    <!-- 线 -->
    <div class="versions_updateHistory_segment"></div>
    <!-- 线 -->

    <!-- 主内容 -->
    <mescroll-vue ref="mescroll" :down="mescrollDown" :up="mescrollUp" @init="mescrollInit">
      <ul class="versions_updateHistory_box_ul" v-if="redataShow">
        <li
          class="versions_updateHistory_box_li"
          @click="particulars(item.id, item.edition_num)"
          v-for="(item, index) in this.redata"
          :key="index"
        >
          <div class="versions_updateHistory_box_liBox">
            <div class="versions_updateHistory_box_liText">版本{{ item.edition_num }}主要更新</div>
            <div class="versions_updateHistory_box_liTime">{{ item.upl_time }}</div>
          </div>
          <img src="../../assets/image/right.png" alt class="versions_updateHistory_box_liImage" />
        </li>
      </ul>

      <!-- 暂无数据 -->
      <div class="versions_updateHistory_box_zanwu" v-else>
        <img src="../../assets/image/wu.png" alt class="versions_updateHistory_box_zanwu_img" />
        <div class="versions_updateHistory_box_zanwu_text">暂无更新记录</div>
      </div>
      <!-- 暂无数据 -->
    </mescroll-vue>

    <!-- 主内容 -->

    <!-- 版本更新主要内容弹框 -->
    <transition name="el-fade-in">
      <div v-if="show" class="mask_layer" :style="'height:' + fullHeight + 'px'">
        <div class="versions_updateHistory_box_popUp">
          <div class="versions_updateHistory_box_popUp_box">
            <!-- 标题 -->
            <div class="versions_updateHistory_box_popUp_box_title">{{ this.renum }}版本更新详细内容</div>
            <!-- 标题 -->
            <img
              @click="close()"
              src="../../assets/image/cheng.png"
              alt
              class="versions_updateHistory_box_popUp_box_image"
            />
          </div>

          <!-- 内容 -->
          <div class="versions_updateHistory_box_popUp_box_content">{{ this.redataA.edition_desc }}</div>
          <!-- 内容 -->
        </div>
      </div>
    </transition>

    <!-- 版本更新主要内容弹框 -->
    <!--  -->
  </div>
</template>

<script>
// 引入mescroll的vue组件
import MescrollVue from "mescroll.js/mescroll.vue";
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {
    MescrollVue // 注册mescroll组件
  },
  data() {
    //这里存放数据
    return {
      loading: true, //加载
      fullHeight: document.documentElement.clientHeight,
      redata: [], //版本记录列表数据
      redataShow: false, //判断是否有数据
      show: false, //弹框是否显示
      renum: "", //版本号
      redataA: [], //详情数据
      //测试
      mescroll: null, // mescroll实例对象
      mescrollDown: {}, //下拉刷新的配置. (如果下拉刷新和上拉加载处理的逻辑是一样的,则mescrollDown可不用写了)
      mescrollUp: {
        // 上拉加载的配置.
        callback: this.upCallback, // 上拉回调,此处简写; 相当于 callback: function(page, mescroll) { }
        //以下是一些常用的配置,当然不写也可以的.
        page: {
          num: 0, //当前页 默认0,回调之前会加1; 即callback(page)会从1开始
          size: 10 //每页数据条数,默认10
        },
        isBounce: true, //根据记录的滚动条高度回弹
        htmlNodata: '<p class="upwarp-nodata">-- 已经到底了! --</p>',
        noMoreSize: 10, //如果列表已无数据,可设置列表的总数量要大于5才显示无更多数据;
        // 避免列表数据过少(比如只有一条数据),显示无更多数据会不好看
        // 这就是为什么无更多数据有时候不显示的原因
        toTop: {
          //回到顶部按钮
          // src: "../../../static/gotop.png", //图片路径,默认null,支持网络图
          src:
            "http://pic.51yuansu.com/pic3/cover/00/65/23/5896fa4bc81fc_610.jpg", //图片路径,默认null,支持网络图
          offset: 800 //列表滚动1000px才显示回到顶部按钮
        },
        onScroll: function(mescroll, y, isUp) {
          //监听滚动条
        },
        lazyLoad: {
          use: true // 是否开启懒加载,默认false
        }
      },
      aggregate: "" //后端传来数据的总条数
    };
  },
  //监听属性 类似于data概念
  computed: {},
  //监控data中的数据变化
  watch: {
    fullHeight(val) {
      //监控浏览器高度变化
      if (!this.timer) {
        this.fullHeight = val;
        this.timer = true;
        let that = this;
        setTimeout(function() {
          //防止过度调用监测事件，导致卡顿
          that.timer = false;
        }, 400);
      }
    }
  },
  beforeRouteEnter(to, from, next) {
    // 如果没有配置顶部按钮或isBounce,则beforeRouteEnter不用写
    next(vm => {
      // 滚动到原来的列表位置,恢复顶部按钮和isBounce的配置
      vm.$refs.mescroll && vm.$refs.mescroll.beforeRouteEnter();
    });
  },
  beforeRouteLeave(to, from, next) {
    // 如果没有配置顶部按钮或isBounce,则beforeRouteLeave不用写
    // 记录列表滚动的位置,隐藏顶部按钮和isBounce的配置
    this.$refs.mescroll && this.$refs.mescroll.beforeRouteLeave();
    next();
  },

  //方法集合
  methods: {
    // mescroll组件初始化的回调,可获取到mescroll对象
    mescrollInit(mescroll) {
      this.mescroll = mescroll; // 如果this.mescroll对象没有使用到,则mescrollInit可以不用配置
    },

    upCallback(page, mescroll) {
      let _this = this;
      this.$axios({
        method: "get",
        url: "bigservers/edition_all",
        params: {
          page: _this.mescrollUp.page.num
        }
      })
        .then(res => {
          _this.loading = false;
          let arr = res.data.dat;
          // 如果是第一页需手动置空列表
          if (page.num === 1) this.redata = [];
          // 把请求到的数据添加到列表
          this.redata = this.redata.concat(arr);
          // 数据渲染成功后,隐藏下拉刷新的状态
          _this.loading = false;
          if (res.data.dat.length === 0) {
            this.redataShow = false;
          } else if (res.data.dat.length !== 0) {
            this.redataShow = true;
            this.redata = res.data.dat;
          }
          this.$nextTick(() => {
            mescroll.endSuccess(arr.length);
          });
        })
        .catch(error => {
          _this.loading = false;
          mescroll.endErr();
          // this.$message({
          //   message: "获取留言列表失败",
          //   type: "error",
          //   duration: 1000
          // });
        });
    },

    //动态获取浏览器高度
    get_boderHeight() {
      const that = this;
      window.onresize = () => {
        return (() => {
          window.fullHeight = document.documentElement.clientHeight;
          that.fullHeight = window.fullHeight;
        })();
      };
    },

    //返回
    FanHui() {
      // this.$router.push("/person");
      this.$router.replace("/person");
    },

    //版本记录数据
    record() {
      let _this = this;
      _this
        .$axios({
          method: "get",
          url: "bigservers/edition_all",
          params: {
            page: 1
          }
        })
        .then(res => {
          if (res.data.dat.length === 0) {
            _this.redataShow = false;
          } else if (res.data.dat.length !== 0) {
            _this.redataShow = true;
            _this.redata = res.data.dat;
          }
        })
        .catch(err => {
          console.log(err);
        });
    },

    //点击显示版本更新的详细内容
    particulars(id, num) {
      // localStorage.setItem('versions_updateHistoryID', id)
      let _this = this;
      _this.renum = num;
      let postData = _this.$qs.parse({
        id: id
      });
      _this
        .$axios({
          method: "post",
          url: "bigservers/edition_all",
          data: postData
        })
        .then(res => {
          _this.show = true;
          _this.redataA = res.data[0];
        })
        .catch(err => {
          console.log(err);
        });
    },

    //点击关闭弹框
    close() {
      this.show = false;
    }
  },
  //生命周期 - 创建完成（可以访问当前this实例）
  created() {
    // this.record(); //版本记录数据
  },
  //生命周期 - 挂载完成（可以访问DOM元素）
  mounted() {}
};
</script>
<style lang='scss'>
@import "../../assets/scss/bus.scss";
@import "../../assets/scss/versions_updateHistory.scss";
//@import url(); 引入公共css类

.versions_updateHistory_box .mescroll {
  position: fixed;
  top: 44px;
  bottom: 0;
  height: auto;
}
</style>